package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class COBTEST5_EMTXDAC {
    public @Getter @Setter @Builder.Default COBTEST5_TX_KEY TX_KEY = new COBTEST5_TX_KEY();
    public @Getter @Builder.Default String TX_LCYM = StringUtils.repeat(' ', 6);
    public @Getter @Setter int TX_LPMT;
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setTX_LCYM(String source) {
        TX_LCYM = StringUtils.truncate(StringUtils.rightPad(source, 6), 6);
    }

    public String getStringTX_LPMT() {
        return intFormatWithoutSign.apply((long) TX_LPMT, "00000");
    }

    public static COBTEST5_EMTXDAC createDefaultValueInstance() {
        return new COBTEST5_EMTXDAC.builder().TX_KEY(
                COBTEST5_TX_KEY.createDefaultValueInstance()).build();
    }

    @Override
    public String toString() {
        return getTX_KEY().toString() + getTX_LCYM() + getStringTX_LPMT();
    }
}
